import { select, 
        json,
        csv,
        tsv, 
        geoPath,
        geoMercator,
        scaleOrdinal,
        schemeCategory10,
        zoom,
        event } from 'd3';
import { feature } from 'topojson';

const svg = select('svg');
const width = parseFloat(svg.attr('width'));
const height = +svg.attr('height');
let stateNames = [];
//declaring projection to be geoMercator
const projection = geoMercator()
			.clipExtent([[0,0],[width,height]])
			.center([140, 30])
			.scale(700);
//declaring path generator to be geopath of geoMercator
const pathGenerator = geoPath()
		.projection(projection);

const g = svg.append('g');

svg.call(zoom().on('zoom', () => {
	g.attr('transform', event.transform)
}));
//linkin the url of data file and getting state and district of Japan
Promise.all([json('https://gist.githubusercontent.com/Rinoj-Gautam/0ab7688dfd4dfc00d4c71c0648e66d8a/raw/fe46d97a7c7cc35404f685f24825aedf35d6bf68/japan.json'),
             json('https://gist.githubusercontent.com/Rinoj-Gautam/0ab7688dfd4dfc00d4c71c0648e66d8a/raw/fe46d97a7c7cc35404f685f24825aedf35d6bf68/japan.json')
            ]).then(([stateJSON, districtJSON]) => {
	//appending State to the graph 
  const stateGroup = g.append('g');
  			
  const states = feature(stateJSON, stateJSON.objects.JPN_adm1);
  
  
  
  const statePath = stateGroup.selectAll('path')
    .data(states.features)
  statePath.enter().append('path')
    .attr('class', 'states')
    .attr('d', d => pathGenerator(d))
});
      